import {
  async,
  TestBed,
} from "@angular/core/testing";
import {RouterTestingModule} from "@angular/router/testing";
import {AppModule} from "@app/app.module";
import {AppState} from "@app/stores/app.state";
import {AppAuthorizedOrganizationalUnitState} from "@app/stores/authorized-organizational-unit/app-authorized-organizational-unit.state";
import {AppOrganizationalUnitPersonRoleState} from "@app/stores/organizational-unit-person-role/app-organizational-unit-person-role.state";
import {AppPersonState} from "@app/stores/person/app-person.state";
import {AppUserState} from "@app/stores/user/app-user.state";
import {NgxsModule} from "@ngxs/store";
import {ENVIRONMENT} from "solidify-frontend";
import {environment} from "../environments/environment";
import {AppComponent} from "./app.component";

describe("AppComponent", () => {
  beforeEach(async(() => {
    TestBed.configureTestingModule({
      imports: [
        RouterTestingModule,
        NgxsModule.forRoot([AppState, AppUserState, AppPersonState, AppAuthorizedOrganizationalUnitState, AppOrganizationalUnitPersonRoleState]),
        AppModule,
      ],
      providers: [
        {
          provide: ENVIRONMENT,
          useValue: environment,
        },
      ],
    }).compileComponents();
  }));

  it("should create the app", () => {
    const fixture = TestBed.createComponent(AppComponent);
    const app = fixture.componentInstance;
    expect(app).toBeTruthy();
  });

  xit(`should have a title not empty`, () => {
    const fixture = TestBed.createComponent(AppComponent);
    const app = fixture.componentInstance;
    expect(app.getTitle()).not.toBe("");
  });

  xit("should render image with unige logo", () => {
    const fixture = TestBed.createComponent(AppComponent);
    fixture.detectChanges();
    const compiled = fixture.nativeElement;
    expect(compiled.querySelector("div.logo>img").src).toContain("unigelogo-white.svg");
  });
});
