import {AdminFundingAgenciesCreateRoutable} from "@admin/funding-agencies/components/routables/admin-funding-agencies-create/admin-funding-agencies-create.routable";
import {AdminFundingAgenciesDetailRoutable} from "@admin/funding-agencies/components/routables/admin-funding-agencies-detail/admin-funding-agencies-detail.routable";
import {AdminFundingAgenciesEditRoutable} from "@admin/funding-agencies/components/routables/admin-funding-agencies-edit/admin-funding-agencies-edit.routable";
import {AdminFundingAgenciesListRoutable} from "@admin/funding-agencies/components/routables/admin-funding-agencies-list/admin-funding-agencies-list.routable";
import {NgModule} from "@angular/core";
import {
  RouterModule,
  Routes,
} from "@angular/router";
import {
  AdminRoutesEnum,
  AppRoutesEnum,
} from "@shared/enums/routes.enum";
import {CanDeactivateGuard} from "@shared/services/can-deactivate-guard.service";
import {TRANSLATE} from "solidify-frontend";

const routes: Routes = [
  {
    path: AppRoutesEnum.root,
    component: AdminFundingAgenciesListRoutable,
    data: {},
  },
  {
    path: AdminRoutesEnum.fundingAgenciesDetail + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: AdminFundingAgenciesDetailRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.funding-agencies.detail"),
    },
  },
  {
    path: AdminRoutesEnum.fundingAgenciesEdit + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: AdminFundingAgenciesEditRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.funding-agencies.edit"),
    },
    canDeactivate: [CanDeactivateGuard],
  },
  {
    component: AdminFundingAgenciesCreateRoutable,
    path: AdminRoutesEnum.fundingAgenciesCreate,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.funding-agencies.create"),
    },
    canDeactivate: [CanDeactivateGuard],
  },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class AdminFundingAgenciesRoutingModule {
}
