import {AdminInstitutionDeleteDialog} from "@admin/institution/components/dialogs/admin-institution-delete/admin-institution-delete.dialog";
import {AdminInstitutionFormPresentational} from "@admin/institution/components/presentationals/admin-institution-form/admin-institution-form.presentational";
import {AdminInstitutionCreateRoutable} from "@admin/institution/components/routables/admin-institution-create/admin-institution-create.routable";
import {AdminInstitutionDetailRoutable} from "@admin/institution/components/routables/admin-institution-detail/admin-institution-detail.routable";
import {AdminInstitutionEditRoutable} from "@admin/institution/components/routables/admin-institution-edit/admin-institution-edit.routable";
import {AdminInstitutionListRoutable} from "@admin/institution/components/routables/admin-institution-list/admin-institution-list.routable";
import {AdminInstitutionRoutingModule} from "@admin/institution/institution-routing.module";
import {AdminInstitutionState} from "@admin/institution/stores/admin-institution.state";
import {NgModule} from "@angular/core";
import {SharedModule} from "@app/shared/shared.module";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";

const routables = [
  AdminInstitutionListRoutable,
  AdminInstitutionDetailRoutable,
  AdminInstitutionEditRoutable,
  AdminInstitutionCreateRoutable,
];
const containers = [];
const dialogs = [
  AdminInstitutionDeleteDialog,
];
const presentationals = [
  AdminInstitutionFormPresentational,
];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...dialogs,
    ...presentationals,
  ],
  imports: [
    SharedModule,
    AdminInstitutionRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      AdminInstitutionState,
    ]),
  ],
  entryComponents: [
    ...dialogs,
  ],
  exports: [
    ...routables,
  ],
  providers: [],
})
export class AdminInstitutionModule {
}
