import {AdminOauth2ClientCreateRoutable} from "@admin/oauth2-client/components/routables/admin-oauth2-client-create/admin-oauth2-client-create.routable";
import {AdminOAuth2ClientDetailRoutable} from "@admin/oauth2-client/components/routables/admin-oauth2-client-detail/admin-oauth2-client-detail.routable";
import {AdminOauth2ClientEditRoutable} from "@admin/oauth2-client/components/routables/admin-oauth2-client-edit/admin-oauth2-client-edit.routable";
import {AdminOAuth2ClientListRoutable} from "@admin/oauth2-client/components/routables/admin-oauth2-client-list/admin-oauth2-client-list.routable";
import {NgModule} from "@angular/core";
import {
  RouterModule,
  Routes,
} from "@angular/router";
import {
  AdminRoutesEnum,
  AppRoutesEnum,
} from "@shared/enums/routes.enum";
import {CanDeactivateGuard} from "@shared/services/can-deactivate-guard.service";
import {TRANSLATE} from "solidify-frontend";

const routes: Routes = [
  {
    path: AppRoutesEnum.root,
    component: AdminOAuth2ClientListRoutable,
    data: {},
  },
  {
    path: AdminRoutesEnum.oauth2clientDetail + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: AdminOAuth2ClientDetailRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.oauth2Client.detail"),
    },
  },
  {
    component: AdminOauth2ClientCreateRoutable,
    path: AdminRoutesEnum.oauth2clientCreate,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.oauth2Client.create"),
    },
    canDeactivate: [CanDeactivateGuard],
  },
  {
    path: AdminRoutesEnum.oauth2clientEdit + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: AdminOauth2ClientEditRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.oauth2Client.edit"),
    },
    canDeactivate: [CanDeactivateGuard],
  },

];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class AdminOauth2ClientRoutingModule {
}
