import {AdminOrgunitCreateRoutable} from "@admin/orgunit/components/routables/admin-orgunit-create/admin-orgunit-create.routable";
import {AdminOrgunitDetailRoutable} from "@admin/orgunit/components/routables/admin-orgunit-detail/admin-orgunit-detail.routable";
import {AdminOrgunitEditRoutable} from "@admin/orgunit/components/routables/admin-orgunit-edit/admin-orgunit-edit.routable";
import {AdminOrgunitListRoutable} from "@admin/orgunit/components/routables/admin-orgunit-list/admin-orgunit-list.routable";
import {NgModule} from "@angular/core";
import {
  RouterModule,
  Routes,
} from "@angular/router";
import {
  AdminRoutesEnum,
  AppRoutesEnum,
} from "@shared/enums/routes.enum";
import {CanDeactivateGuard} from "@shared/services/can-deactivate-guard.service";
import {TRANSLATE} from "solidify-frontend";

const routes: Routes = [
  {
    path: AppRoutesEnum.root,
    component: AdminOrgunitListRoutable,
    data: {},
  },
  {
    path: AdminRoutesEnum.organizationalUnitDetail + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: AdminOrgunitDetailRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.organizationalUnit.detail"),
    },
  },
  {
    path: AdminRoutesEnum.organizationalUnitEdit + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: AdminOrgunitEditRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.organizationalUnit.edit"),
    },
    canDeactivate: [CanDeactivateGuard],
  },
  {
    path: AdminRoutesEnum.organizationalUnitCreate,
    component: AdminOrgunitCreateRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.organizationalUnit.create"),
    },
    canDeactivate: [CanDeactivateGuard],
  },

];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class AdminOrgunitRoutingModule {
}
