"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var admin_person_create_routable_1 = require("@admin/person/components/routables/create/admin-person-create.routable");
var admin_person_detail_routable_1 = require("@admin/person/components/routables/detail/admin-person-detail.routable");
var admin_person_edit_routable_1 = require("@admin/person/components/routables/edit/admin-person-edit.routable");
var admin_person_list_routable_1 = require("@admin/person/components/routables/list/admin-person-list-routable");
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var application_role_permission_enum_1 = require("@shared/enums/application-role-permission.enum");
var routes_enum_1 = require("@shared/enums/routes.enum");
var application_role_guard_service_1 = require("@shared/guards/application-role-guard.service");
var solidify_frontend_1 = require("solidify-frontend");
var routes = [
    {
        path: routes_enum_1.AppRoutesEnum.root,
        component: admin_person_list_routable_1.AdminPersonListRoutable,
        data: {
            breadcrumb: solidify_frontend_1.TRANSLATE("breadcrumb.admin.person.list"),
            permission: application_role_permission_enum_1.ApplicationRolePermissionEnum.rootPermission,
        },
        canActivate: [application_role_guard_service_1.ApplicationRoleGuardService],
    },
    {
        path: routes_enum_1.AdminRoutesEnum.personDetail + routes_enum_1.AppRoutesEnum.separator + routes_enum_1.AppRoutesEnum.paramId,
        component: admin_person_detail_routable_1.AdminPersonDetailRoutable,
        data: {
            breadcrumb: solidify_frontend_1.TRANSLATE("breadcrumb.admin.person.detail"),
            permission: application_role_permission_enum_1.ApplicationRolePermissionEnum.rootPermission,
        },
    },
    {
        path: routes_enum_1.AdminRoutesEnum.personCreate,
        component: admin_person_create_routable_1.AdminPersonCreateRoutable,
        data: {
            breadcrumb: solidify_frontend_1.TRANSLATE("breadcrumb.admin.person.create"),
        },
    },
    {
        path: routes_enum_1.AdminRoutesEnum.personEdit + routes_enum_1.AppRoutesEnum.separator + routes_enum_1.AppRoutesEnum.paramId,
        component: admin_person_edit_routable_1.AdminPersonEditRoutable,
        data: {
            breadcrumb: solidify_frontend_1.TRANSLATE("breadcrumb.admin.person.edit"),
        },
    },
];
var AdminPersonRoutingModule = /** @class */ (function () {
    function AdminPersonRoutingModule() {
    }
    AdminPersonRoutingModule = __decorate([
        core_1.NgModule({
            imports: [router_1.RouterModule.forChild(routes)],
            exports: [router_1.RouterModule],
        })
    ], AdminPersonRoutingModule);
    return AdminPersonRoutingModule;
}());
exports.AdminPersonRoutingModule = AdminPersonRoutingModule;
