import {AdminPreservationPolicyCreateRoutable} from "@admin/preservation-policy/components/routables/admin-preservation-policy-create/admin-preservation-policy-create.routable";
import {AdminPreservationPolicyDetailRoutable} from "@admin/preservation-policy/components/routables/admin-preservation-policy-detail/admin-preservation-policy-detail.routable";
import {AdminPreservationPolicyEditRoutable} from "@admin/preservation-policy/components/routables/admin-preservation-policy-edit/admin-preservation-policy-edit.routable";
import {AdminPreservationPolicyListRoutable} from "@admin/preservation-policy/components/routables/admin-preservation-policy-list/admin-preservation-policy-list.routable";
import {NgModule} from "@angular/core";
import {
  RouterModule,
  Routes,
} from "@angular/router";
import {
  AdminRoutesEnum,
  AppRoutesEnum,
} from "@shared/enums/routes.enum";
import {CanDeactivateGuard} from "@shared/services/can-deactivate-guard.service";
import {TRANSLATE} from "solidify-frontend";

const routes: Routes = [
  {
    path: AppRoutesEnum.root,
    component: AdminPreservationPolicyListRoutable,
    data: {},
  },
  {
    path: AdminRoutesEnum.preservationPolicyDetail + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: AdminPreservationPolicyDetailRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.preservationPolicy.detail"),
    },
  },
  {
    path: AdminRoutesEnum.preservationPolicyCreate,
    component: AdminPreservationPolicyCreateRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.preservationPolicy.create"),
    },
    canDeactivate: [CanDeactivateGuard],
  },
  {
    path: AdminRoutesEnum.preservationPolicyEdit + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: AdminPreservationPolicyEditRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.preservationPolicy.edit"),
    },
    canDeactivate: [CanDeactivateGuard],
  },

];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class AdminPreservationPolicyRoutingModule {
}
