import {AdminRoleDetailRoutable} from "@admin/role/components/routables/admin-role-detail/admin-role-detail.routable";
import {AdminRoleEditRoutable} from "@admin/role/components/routables/admin-role-edit/admin-role-edit.routable";
import {AdminRoleListRoutable} from "@admin/role/components/routables/admin-role-list/admin-role-list.routable";
import {NgModule} from "@angular/core";
import {
  RouterModule,
  Routes,
} from "@angular/router";
import {
  AdminRoutesEnum,
  AppRoutesEnum,
} from "@shared/enums/routes.enum";
import {CanDeactivateGuard} from "@shared/services/can-deactivate-guard.service";
import {TRANSLATE} from "solidify-frontend";

const routes: Routes = [
  {
    path: AppRoutesEnum.root,
    component: AdminRoleListRoutable,
    data: {},
  },
  {
    path: AdminRoutesEnum.roleDetail + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: AdminRoleDetailRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.role.detail"),
    },
  },
  {
    path: AdminRoutesEnum.roleEdit + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: AdminRoleEditRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.role.edit"),
    },
    canDeactivate: [CanDeactivateGuard],
  },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class AdminRoleRoutingModule {
}
