import {AdminSubmissionPolicyCreateRoutable} from "@admin/submission-policy/components/routables/admin-submission-policy-create/admin-submission-policy-create.routable";
import {AdminSubmissionPolicyDetailRoutable} from "@admin/submission-policy/components/routables/admin-submission-policy-detail/admin-submission-policy-detail.routable";
import {AdminSubmissionPolicyEditRoutable} from "@admin/submission-policy/components/routables/admin-submission-policy-edit/admin-submission-policy-edit.routable";
import {AdminSubmissionPolicyListRoutable} from "@admin/submission-policy/components/routables/admin-submission-policy-list/admin-submission-policy-list.routable";
import {NgModule} from "@angular/core";
import {
  RouterModule,
  Routes,
} from "@angular/router";
import {
  AdminRoutesEnum,
  AppRoutesEnum,
} from "@shared/enums/routes.enum";
import {CanDeactivateGuard} from "@shared/services/can-deactivate-guard.service";
import {TRANSLATE} from "solidify-frontend";

const routes: Routes = [
  {
    path: AppRoutesEnum.root,
    component: AdminSubmissionPolicyListRoutable,
    data: {},
  },
  {
    path: AdminRoutesEnum.submissionPolicyDetail + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: AdminSubmissionPolicyDetailRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.submissionPolicy.detail"),
    },
  },
  {
    path: AdminRoutesEnum.submissionPolicyEdit + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: AdminSubmissionPolicyEditRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.submissionPolicy.edit"),
    },
    canDeactivate: [CanDeactivateGuard],
  },
  {
    path: AdminRoutesEnum.submissionPolicyCreate,
    component: AdminSubmissionPolicyCreateRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.admin.submissionPolicy.create"),
    },
    canDeactivate: [CanDeactivateGuard],
  },

];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class AdminSubmissionPolicyRoutingModule {
}
