import {
  ChangeDetectionStrategy,
  Component,
  Inject,
} from "@angular/core";
import {
  MAT_DIALOG_DATA,
  MatDialogRef,
} from "@angular/material";
import {DepositExtended} from "@app/features/deposit/models/deposits-extended.model";
import {depositActionNameSpace} from "@app/features/deposit/stores/deposit.action";
import {DepositStateModel} from "@app/features/deposit/stores/deposit.state";
import {SharedAbstractDeleteDialog} from "@app/shared/components/dialogs/shared-abstract-delete/shared-abstract-delete.dialog";
import {DeleteDialog} from "@app/shared/models/delete-dialog.model";
import {Store} from "@ngxs/store";
import {TRANSLATE} from "solidify-frontend";
import {LocalStateEnum} from "../../../../../shared/enums/local-state.enum";

@Component({
  selector: "dlcm-deposit-delete-dialog",
  templateUrl: "../../../../../shared/components/dialogs/shared-abstract-delete/shared-abstract-delete.dialog.html",
  styleUrls: ["../../../../../shared/components/dialogs/shared-abstract-delete/shared-abstract-delete.dialog.scss"],
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class DepositDeleteDialog extends SharedAbstractDeleteDialog<DepositExtended, DepositStateModel> {
  public readonly KEY_TITLE: string = TRANSLATE("deposit.dialog.delete.title");
  public readonly KEY_MESSAGE: string = TRANSLATE("deposit.dialog.delete.message");
  public readonly KEY_CONFIRM_BUTTON: string = TRANSLATE("deposit.dialog.delete.confirm");
  public readonly KEY_CANCEL_BUTTON: string = TRANSLATE("deposit.dialog.delete.cancel");

  constructor(protected store: Store,
              protected dialogRef: MatDialogRef<DepositDeleteDialog>,
              @Inject(MAT_DIALOG_DATA) public data: DeleteDialog) {
    super(store, dialogRef, data, LocalStateEnum.deposit, depositActionNameSpace);
  }

}
