import {
  ChangeDetectionStrategy,
  Component,
  Inject,
  OnInit,
} from "@angular/core";
import {
  MAT_DIALOG_DATA,
  MatDialogRef,
} from "@angular/material";
import {DepositDataFile} from "@app/features/deposit/models/deposit-data-file.model";
import {SharedAbstractContainer} from "@app/shared/components/containers/shared-abstract/shared-abstract.container";

@Component({
  selector: "dlcm-deposit-file-detail-dialog",
  templateUrl: "./deposit-file-detail.dialog.html",
  styleUrls: ["./deposit-file-detail.dialog.scss"],
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class DepositFileDetailDialog extends SharedAbstractContainer implements OnInit {
  paramMessage: { name: string } = {name: ""};

  constructor(protected dialogRef: MatDialogRef<DepositFileDetailDialog>,
              @Inject(MAT_DIALOG_DATA) public data: DepositDataFile) {
    super();
  }

  ngOnInit(): void {
    super.ngOnInit();
    this.paramMessage.name = this.data.fileName;
  }

  close(): void {
    this.dialogRef.close();
  }
}
