import {LocalStateEnum} from "@app/shared/enums/local-state.enum";
import {StatusHistoryNamespace} from "@shared/stores/status-history/status-history-namespace.model";
import {StatusHistoryAction} from "@shared/stores/status-history/status-history.action";
import {TypeDefaultAction} from "solidify-frontend";

const state = LocalStateEnum.deposit_dataFile_statusHistory;

export namespace DepositDataFileStatusHistoryAction {

  @TypeDefaultAction(state)
  export class History extends StatusHistoryAction.History {
  }

  @TypeDefaultAction(state)
  export class HistorySuccess extends StatusHistoryAction.HistorySuccess {
  }

  @TypeDefaultAction(state)
  export class HistoryFail extends StatusHistoryAction.HistoryFail {
  }
}

export const depositDataFileStatusHistoryNamespace: StatusHistoryNamespace = DepositDataFileStatusHistoryAction;
