import {depositPersonActionNameSpace} from "@app/features/deposit/stores/people/deposit-person.action";
import {Person} from "@app/generated-api";
import {ApiResourceNameEnum} from "@app/shared/enums/api-resource-name.enum";
import {PreIngestResourceApiEnum} from "@app/shared/enums/api.enum";
import {LocalStateEnum} from "@app/shared/enums/local-state.enum";

import {
  Actions,
  State,
  Store,
} from "@ngxs/store";
import {
  ApiService,
  AssociationRemoteState,
  AssociationRemoteStateModel,
  defaultAssociationRemoteStateInitValue,
  NotificationService,
} from "solidify-frontend";

export interface DepositPersonStateModel extends AssociationRemoteStateModel<Person> {
}

@State<DepositPersonStateModel>({
  name: LocalStateEnum.deposit_person,
  defaults: {
    ...defaultAssociationRemoteStateInitValue,
  },
})
export class DepositPeopleState extends AssociationRemoteState<Person> {

  constructor(protected apiService: ApiService,
              protected store: Store,
              protected notificationService: NotificationService,
              protected actions$: Actions) {
    super(apiService, store, notificationService, actions$, {
      nameSpace: depositPersonActionNameSpace,
      resourceName: ApiResourceNameEnum.PERSON,
    });
  }

  protected get _urlResource(): string {
    return PreIngestResourceApiEnum.deposits;
  }
}
