import {NgModule} from "@angular/core";
import {HomeBrowsingArchivePresentational} from "@app/features/home/components/presentationals/home-browsing-archive/home-browsing-archive.presentational";
import {HomeBrowsingOrgUnitPresentational} from "@app/features/home/components/presentationals/home-browsing-org-unit/home-browsing-org-unit.presentational";
import {HomeRssDetailPresentational} from "@app/features/home/components/presentationals/home-rss-detail/home-rss-detail.presentational";
import {HomeRssWrapperPresentational} from "@app/features/home/components/presentationals/home-rss-wrapper/home-rss-wrapper.presentational";
import {HomeSearchScopePresentational} from "@app/features/home/components/presentationals/home-search-scope/home-search-scope.presentational";
import {HomeTwitterWidgetPresentational} from "@app/features/home/components/presentationals/home-tweet-detail/home-twitter-widget.presentational";
import {HomeTwitterWrapperPresentational} from "@app/features/home/components/presentationals/home-tweet-wrapper/home-tweeter-wrapper.presentational";
import {HomeBrowsingListArchivesRoutable} from "@app/features/home/components/routables/home-browsing-list-archives/home-browsing-list-archives.routable";
import {HomeBrowsingRoutable} from "@app/features/home/components/routables/home-browsing/home-browsing.routable";
import {HomeDetailRoutable} from "@app/features/home/components/routables/home-detail/home-detail.routable";
import {HomeSearchRoutable} from "@app/features/home/components/routables/home-search/home-search.routable";
import {HomeRoutingModule} from "@app/features/home/home-routing.module";
import {TwitterService} from "@app/features/home/services/twitter.service";
import {HomeState} from "@app/features/home/stores/home.state";
import {HomeOrganizationalUnitArchiveState} from "@app/features/home/stores/organizational-unit/archive/home-organizational-unit-archive.state";
import {HomeOrganizationalUnitState} from "@app/features/home/stores/organizational-unit/home-organizational-unit.state";
import {SharedModule} from "@app/shared/shared.module";
import {HomeArchiveDetailPresentational} from "@home/components/presentationals/home-archive-form/home-archive-detail.presentational";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";
import {HighlightModule} from "ngx-highlightjs";

const routables = [
  HomeSearchRoutable,
  HomeDetailRoutable,
  HomeBrowsingRoutable,
  HomeBrowsingListArchivesRoutable,
];
const containers = [];
const presentationals = [
  HomeArchiveDetailPresentational,
  HomeSearchScopePresentational,
  HomeTwitterWrapperPresentational,
  HomeTwitterWidgetPresentational,
  HomeRssWrapperPresentational,
  HomeRssDetailPresentational,
  HomeBrowsingOrgUnitPresentational,
  HomeBrowsingArchivePresentational,
];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...presentationals,
  ],
  imports: [
    SharedModule,
    HomeRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      HomeState,
      HomeOrganizationalUnitState,
      HomeOrganizationalUnitArchiveState,
    ]),
    HighlightModule,
  ],
  exports: [
    ...routables,
  ],
  providers: [
    TwitterService,
  ],
})
export class HomeModule {
}
