import {AccessOrganizationalUnit} from "@app/generated-api";
import {LocalStateEnum} from "@app/shared/enums/local-state.enum";
import {
  CollectionTyped,
  QueryParameters,
  ResourceAction,
  ResourceNameSpace,
  TypeDefaultAction,
} from "solidify-frontend";

const state = LocalStateEnum.home_organizationalUnit;

export namespace HomeOrgUnitAction {
  @TypeDefaultAction(state)
  export class LoadResource extends ResourceAction.LoadResource {
  }

  @TypeDefaultAction(state)
  export class LoadResourceSuccess extends ResourceAction.LoadResourceSuccess {
  }

  @TypeDefaultAction(state)
  export class LoadResourceFail extends ResourceAction.LoadResourceFail {
  }

  @TypeDefaultAction(state)
  export class ChangeQueryParameters extends ResourceAction.ChangeQueryParameters {
  }

  @TypeDefaultAction(state)
  export class GetAll extends ResourceAction.GetAll {
  }

  @TypeDefaultAction(state)
  export class GetAllSuccess extends ResourceAction.GetAllSuccess<AccessOrganizationalUnit> {
  }

  @TypeDefaultAction(state)
  export class GetAllFail extends ResourceAction.GetAllFail<AccessOrganizationalUnit> {
  }

  @TypeDefaultAction(state)
  export class GetById extends ResourceAction.GetById {
  }

  @TypeDefaultAction(state)
  export class GetByIdSuccess extends ResourceAction.GetByIdSuccess<AccessOrganizationalUnit> {
  }

  @TypeDefaultAction(state)
  export class GetByIdFail extends ResourceAction.GetByIdFail<AccessOrganizationalUnit> {
  }

  @TypeDefaultAction(state)
  export class Create extends ResourceAction.Create<AccessOrganizationalUnit> {
  }

  @TypeDefaultAction(state)
  export class CreateSuccess extends ResourceAction.CreateSuccess<AccessOrganizationalUnit> {
  }

  @TypeDefaultAction(state)
  export class CreateFail extends ResourceAction.CreateFail<AccessOrganizationalUnit> {
  }

  @TypeDefaultAction(state)
  export class Update extends ResourceAction.Update<AccessOrganizationalUnit> {
  }

  @TypeDefaultAction(state)
  export class UpdateSuccess extends ResourceAction.UpdateSuccess<AccessOrganizationalUnit> {
  }

  @TypeDefaultAction(state)
  export class UpdateFail extends ResourceAction.UpdateFail<AccessOrganizationalUnit> {
  }

  @TypeDefaultAction(state)
  export class Delete extends ResourceAction.Delete {
  }

  @TypeDefaultAction(state)
  export class DeleteSuccess extends ResourceAction.DeleteSuccess {
  }

  @TypeDefaultAction(state)
  export class DeleteFail extends ResourceAction.DeleteFail {
  }

  @TypeDefaultAction(state)
  export class Clean extends ResourceAction.Clean {
  }

  export class Search {
    static readonly type: string = "[${state}] Search";

    constructor(public resetPagination: boolean, public search?: string, public queryParameters?: QueryParameters) {
    }
  }

  export class GetDefaultMaximumOrgUnit {
    static readonly type: string = "[${state}] Get Default Maximum Org Unit";

    constructor() {
    }
  }

  export class GetDefaultMaximumSuccess {
    static readonly type: string = "[${state}] Get Default Maximum Org Unit Success";

    constructor(public list?: CollectionTyped<AccessOrganizationalUnit> | null | undefined) {
    }
  }

  export class GetDefaultMaximumFail {
    static readonly type: string = "[${state}] Get Default Maximum Org Unit Fail";
  }
}

export const homeOrgUnitActionNameSpace: ResourceNameSpace = HomeOrgUnitAction;
