import {
  ChangeDetectionStrategy,
  Component,
} from "@angular/core";
import {ActivatedRoute} from "@angular/router";
import {OrganizationalUnitExtended} from "@app/features/deposit/models/organizational-unit-extended.model";
import {orgUnitActionNameSpace} from "@app/features/organizational-unit/stores/organizational-unit.action";
import {OrganizationalUnitStateModel} from "@app/features/organizational-unit/stores/organizational-unit.state";
import {
  PreservationPolicy,
  SubmissionPolicy,
} from "@app/generated-api";
import {SharedAbstractEditRoutable} from "@app/shared/components/routables/shared-abstract-edit/shared-abstract-edit.routable";
import {LocalStateEnum} from "@app/shared/enums/local-state.enum";
import {LocalStateModel} from "@app/shared/models/local-state.model";
import {
  Select,
  Store,
} from "@ngxs/store";
import {Observable} from "rxjs";

@Component({
  selector: "dlcm-orgunit-edit-routable",
  templateUrl: "./orgunit-edit.routable.html",
  styleUrls: ["../../../../../shared/components/routables/shared-abstract-edit/shared-abstract-edit.routable.scss"],
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class OrgunitEditRoutable extends SharedAbstractEditRoutable<OrganizationalUnitExtended, OrganizationalUnitStateModel> {
  @Select((state: LocalStateModel) => state.shared.shared_submissionPolicy.list) listSubmissionPoliciesObs: Observable<SubmissionPolicy[]>;
  @Select((state: LocalStateModel) => state.shared.shared_preservationPolicy.list) listPreservationPoliciesObs: Observable<PreservationPolicy[]>;

  constructor(protected store: Store,
              protected route: ActivatedRoute) {
    super(store, route, LocalStateEnum.organizationalUnit, orgUnitActionNameSpace);
  }

  getSubResourceWithParentId(id: string): void {
  }
}
