import {NgModule} from "@angular/core";
import {RouterModule} from "@angular/router";
import {OrgunitDetailRoutable} from "@app/features/organizational-unit/components/routables/orgunit-detail/orgunit-detail.routable";
import {OrgunitEditRoutable} from "@app/features/organizational-unit/components/routables/orgunit-edit/orgunit-edit.routable";
import {OrgunitListRoutable} from "@app/features/organizational-unit/components/routables/orgunit-list/orgunit-list.routable";
import {
  AppRoutesEnum,
  OrganizationalUnitRoutesEnum,
} from "@app/shared/enums/routes.enum";
import {DlcmRoutes} from "@app/shared/models/dlcm-route.model";
import {CanDeactivateGuard} from "@shared/services/can-deactivate-guard.service";
import {TRANSLATE} from "solidify-frontend";

const routes: DlcmRoutes = [
  {
    path: "",
    component: OrgunitListRoutable,
    data: {},
  },
  {
    path: OrganizationalUnitRoutesEnum.detail + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: OrgunitDetailRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.organizationalUnit.detail"),
    },
  },
  {
    path: OrganizationalUnitRoutesEnum.edit + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: OrgunitEditRoutable,
    data: {
      breadcrumb: TRANSLATE("breadcrumb.organizationalUnit.edit"),
    },
    canDeactivate: [CanDeactivateGuard],
  },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class OrganizationalUnitRoutingModule {
}
