import {
  ChangeDetectionStrategy,
  Component,
  Input,
} from "@angular/core";
import {
  ControlValueAccessor,
  FormControl,
  NG_VALUE_ACCESSOR,
} from "@angular/forms";
import {SharedMultiSelectPresentational} from "@app/shared/components/presentationals/shared-multi-select/shared-multi-select.presentational";
import {isNullOrUndefined} from "solidify-frontend";

@Component({
  selector: "dlcm-shared-multi-select-default-value",
  templateUrl: "./shared-multi-select-default-value.presentational.html",
  styleUrls: ["./shared-multi-select-default-value.presentational.scss"],
  changeDetection: ChangeDetectionStrategy.OnPush,
  providers: [
    {
      provide: NG_VALUE_ACCESSOR,
      multi: true,
      useExisting: SharedMultiSelectDefaultValuePresentational,
    },
  ],
})
export class SharedMultiSelectDefaultValuePresentational extends SharedMultiSelectPresentational implements ControlValueAccessor {
  @Input()
  formControlDefault: FormControl;

  stopPropagation($event: MouseEvent): void {
    $event.stopPropagation();
  }

  defineDefaultOption(): void {
    if (!isNullOrUndefined(this.formControl.value) && !this.formControl.value.includes(this.formControlDefault.value)) {
      if (this.formControl.value.length > 0) {
        this.formControlDefault.setValue(this.formControl.value[0]);
      } else {
        this.formControlDefault.setValue(undefined);
      }
    }
  }
}
