import {
  AfterViewInit,
  ChangeDetectionStrategy,
  Component,
  Input,
  OnInit,
  Output,
} from "@angular/core";
import {FormBuilder} from "@angular/forms";
import {Store} from "@ngxs/store";
import {SharedSearchableAbstractContentPresentational} from "@shared/components/presentationals/shared-searchable-abstract-content/shared-searchable-abstract-content.presentational";
import {SharedSearchableMultiSelectPresentational} from "@shared/components/presentationals/shared-searchable-multi-select/shared-searchable-multi-select.presentational";
import {
  BehaviorSubject,
  Observable,
} from "rxjs";
import {ObservableUtil} from "solidify-frontend";

@Component({
  selector: "dlcm-shared-searchable-multi-select-content",
  templateUrl: "./shared-searchable-multi-select-content.presentational.html",
  styleUrls: ["./shared-searchable-multi-select-content.presentational.scss"],
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class SharedSearchableMultiSelectContentPresentational extends SharedSearchableAbstractContentPresentational implements OnInit, AfterViewInit {
  @Input()
  host: SharedSearchableMultiSelectPresentational;

  private readonly _valueAddedBS: BehaviorSubject<any | undefined> = new BehaviorSubject<any | undefined>(undefined);
  @Output("valueAddedChange")
  readonly valueAddedObs: Observable<any | undefined> = ObservableUtil.asObservable(this._valueAddedBS);

  private readonly _valueRemovedBS: BehaviorSubject<any | undefined> = new BehaviorSubject<any | undefined>(undefined);
  @Output("valueRemovedChange")
  readonly valueRemovedObs: Observable<any | undefined> = ObservableUtil.asObservable(this._valueRemovedBS);

  constructor(protected store: Store,
              protected _fb: FormBuilder) {
    super(store, _fb);
  }

  select(value: any): void {
    if (this.isActive(value)) {
      this._valueRemovedBS.next(value);
      return;
    }
    this._valueAddedBS.next(value);
  }
}



