import {
  AfterViewInit,
  ChangeDetectionStrategy,
  Component,
  Input,
  OnInit,
  Output,
} from "@angular/core";
import {FormBuilder} from "@angular/forms";
import {Store} from "@ngxs/store";
import {SharedSearchableAbstractContentPresentational} from "@shared/components/presentationals/shared-searchable-abstract-content/shared-searchable-abstract-content.presentational";
import {SharedSearchableSingleSelectPresentational} from "@shared/components/presentationals/shared-searchable-single-select/shared-searchable-single-select.presentational";
import {
  BehaviorSubject,
  Observable,
} from "rxjs";
import {ObservableUtil} from "solidify-frontend";

@Component({
  selector: "dlcm-shared-searchable-single-select-content",
  templateUrl: "./shared-searchable-single-select-content.presentational.html",
  styleUrls: ["./shared-searchable-single-select-content.presentational.scss"],
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class SharedSearchableSingleSelectContentPresentational extends SharedSearchableAbstractContentPresentational implements OnInit, AfterViewInit {
  @Input()
  host: SharedSearchableSingleSelectPresentational;

  private readonly _valueBS: BehaviorSubject<any | undefined> = new BehaviorSubject<any | undefined>(undefined);
  @Output("valueChange")
  readonly valueObs: Observable<any | undefined> = ObservableUtil.asObservable(this._valueBS);

  constructor(protected store: Store,
              protected _fb: FormBuilder) {
    super(store, _fb);
  }

  select(value: any): void {
    if (this.isActive(value)) {
      return;
    }
    this._valueBS.next(value);
  }
}



