import {SharedAbstractRoutable} from "@app/shared/components/routables/shared-abstract/shared-abstract.routable";
import {LocalStateEnum} from "@app/shared/enums/local-state.enum";
import {
  isNullOrUndefined,
  ResourceStateModel,
} from "solidify-frontend";

export abstract class SharedAbstractResourceRoutable<TResourceModel, UResourceStateModel extends ResourceStateModel<TResourceModel>> extends SharedAbstractRoutable {
  protected constructor(protected state: LocalStateEnum,
                        protected parentState?: LocalStateEnum) {
    super();
  }

  protected getState(rootStateModel: any): UResourceStateModel {
    if (isNullOrUndefined(this.parentState)) {
      return rootStateModel[this.state];
    }
    return rootStateModel[this.parentState][this.state];
  }
}
