export const urlSeparator: string = "/";

export enum AppRoutesEnum {
  root = "",
  index = "index",
  login = "login",
  homePage = "home",
  deposit = "deposit",
  organizationalUnit = "organizational-unit",
  admin = "admin",
  separator = "/",
  paramId = ":id",
  paramIdWithoutPrefixParam = "id",
}

export enum HomePageRoutesEnum {
  detail = "detail",
  browsing = "browsing",
}

export enum DepositRoutesEnum {
  create = "create",
  detail = "detail",
  edit = "edit",
  metadata = "metadata",
  file = "file",
}

export enum OrganizationalUnitRoutesEnum {
  detail = "detail",
  edit = "edit",
}

export enum AdminRoutesEnum {
  submissionPolicy = "submission-policy",
  submissionPolicyCreate = "create",
  submissionPolicyDetail = "detail",
  submissionPolicyEdit = "edit",

  preservationPolicy = "preservation-policy",
  preservationPolicyDetail = "detail",
  preservationPolicyCreate = "create",
  preservationPolicyEdit = "edit",

  license = "license",
  licenseCreate = "create",
  licenseEdit = "edit",
  licenseDetail = "detail",

  organizationalUnit = "organizational-unit",
  organizationalUnitCreate = "create",
  organizationalUnitDetail = "detail",
  organizationalUnitEdit = "edit",

  institution = "institution",
  institutionCreate = "create",
  institutionDetail = "detail",
  institutionEdit = "edit",

  user = "user",
  userDetail = "detail",
  userCreate = "create",
  userEdit = "edit",

  oauth2client = "oauth2-clients",
  oauth2clientCreate = "create",
  oauth2clientDetail = "detail",
  oauth2clientEdit = "edit",

  person = "person",
  personDetail = "detail",
  personCreate = "create",
  personEdit = "edit",

  role = "role",
  roleDetail = "detail",
  roleCreate = "create",
  roleEdit = "edit",

  fundingAgencies = "funding-agencies",
  fundingAgenciesDetail = "detail",
  fundingAgenciesCreate = "create",
  fundingAgenciesEdit = "edit",
}

export class RoutesEnum implements RoutesEnum {
  static index: string = AppRoutesEnum.index;
  static login: string = AppRoutesEnum.login;

  static homePage: string = AppRoutesEnum.homePage;
  static homePageDetail: string = AppRoutesEnum.homePage + urlSeparator + HomePageRoutesEnum.detail;
  static homePageBrowsing: string = AppRoutesEnum.homePage + urlSeparator + HomePageRoutesEnum.browsing;

  static deposit: string = AppRoutesEnum.deposit;
  static depositCreate: string = AppRoutesEnum.deposit + urlSeparator + DepositRoutesEnum.create;
  static depositDetail: string = AppRoutesEnum.deposit + urlSeparator + DepositRoutesEnum.detail;
  static depositEdit: string = AppRoutesEnum.deposit + urlSeparator + DepositRoutesEnum.edit;

  static organizationalUnit: string = AppRoutesEnum.organizationalUnit;
  static organizationalUnitDetail: string = AppRoutesEnum.organizationalUnit + urlSeparator + OrganizationalUnitRoutesEnum.detail;
  static organizationalUnitEdit: string = AppRoutesEnum.organizationalUnit + urlSeparator + OrganizationalUnitRoutesEnum.edit;

  static admin: string = AppRoutesEnum.admin;

  static adminSubmissionPolicy: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.submissionPolicy;
  static adminSubmissionPolicyCreate: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.submissionPolicy + urlSeparator + AdminRoutesEnum.submissionPolicyCreate;
  static adminSubmissionPolicyDetail: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.submissionPolicy + urlSeparator + AdminRoutesEnum.submissionPolicyDetail;
  static adminSubmissionPolicyEdit: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.submissionPolicy + urlSeparator + AdminRoutesEnum.submissionPolicyEdit;

  static adminPreservationPolicy: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.preservationPolicy;
  static adminPreservationPolicyCreate: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.preservationPolicy + urlSeparator + AdminRoutesEnum.preservationPolicyCreate;
  static adminPreservationPolicyDetail: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.preservationPolicy + urlSeparator + AdminRoutesEnum.preservationPolicyDetail;
  static adminPreservationPolicyEdit: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.preservationPolicy + urlSeparator + AdminRoutesEnum.preservationPolicyEdit;

  static adminLicense: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.license;
  static adminLicenseCreate: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.license + urlSeparator + AdminRoutesEnum.licenseCreate;
  static adminLicenseDetail: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.license + urlSeparator + AdminRoutesEnum.licenseDetail;
  static adminLicenseEdit: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.license + urlSeparator + AdminRoutesEnum.licenseEdit;

  static adminOrganizationalUnit: string = AppRoutesEnum.admin + urlSeparator + AppRoutesEnum.organizationalUnit;
  static adminOrganizationalUnitCreate: string = AppRoutesEnum.admin + urlSeparator + AppRoutesEnum.organizationalUnit + urlSeparator + AdminRoutesEnum.organizationalUnitCreate;
  static adminOrganizationalUnitDetail: string = AppRoutesEnum.admin + urlSeparator + AppRoutesEnum.organizationalUnit + urlSeparator + AdminRoutesEnum.organizationalUnitDetail;
  static adminOrganizationalUnitEdit: string = AppRoutesEnum.admin + urlSeparator + AppRoutesEnum.organizationalUnit + urlSeparator + AdminRoutesEnum.organizationalUnitEdit;

  static adminInstitution: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.institution;
  static adminInstitutionCreate: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.institution + urlSeparator + AdminRoutesEnum.institutionCreate;
  static adminInstitutionDetail: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.institution + urlSeparator + AdminRoutesEnum.institutionDetail;
  static adminInstitutionEdit: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.institution + urlSeparator + AdminRoutesEnum.institutionEdit;

  static adminUser: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.user;
  static adminUserCreate: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.user + urlSeparator + AdminRoutesEnum.userCreate;
  static adminUserDetail: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.user + urlSeparator + AdminRoutesEnum.userDetail;
  static adminUserEdit: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.user + urlSeparator + AdminRoutesEnum.userEdit;

  static adminOAuth2client: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.oauth2client;
  static adminOAuth2clientDetail: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.oauth2client + urlSeparator + AdminRoutesEnum.oauth2clientDetail;
  static adminOAuth2clientEdit: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.oauth2client + urlSeparator + AdminRoutesEnum.oauth2clientEdit;
  static adminOAuth2clientCreate: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.oauth2client + urlSeparator + AdminRoutesEnum.oauth2clientCreate;

  static adminPerson: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.person;
  static adminPersonCreate: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.person + urlSeparator + AdminRoutesEnum.personCreate;
  static adminPersonDetail: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.person + urlSeparator + AdminRoutesEnum.personDetail;
  static adminPersonEdit: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.person + urlSeparator + AdminRoutesEnum.personEdit;

  static adminRole: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.role;
  static adminRoleCreate: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.role + urlSeparator + AdminRoutesEnum.roleCreate;
  static adminRoleDetail: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.role + urlSeparator + AdminRoutesEnum.roleDetail;
  static adminRoleEdit: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.role + urlSeparator + AdminRoutesEnum.roleEdit;

  static adminFundingAgencies: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.fundingAgencies;
  static adminFundingAgenciesCreate: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.fundingAgencies + urlSeparator + AdminRoutesEnum.fundingAgenciesCreate;
  static adminFundingAgenciesDetail: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.fundingAgencies + urlSeparator + AdminRoutesEnum.fundingAgenciesDetail;
  static adminFundingAgenciesEdit: string = AppRoutesEnum.admin + urlSeparator + AdminRoutesEnum.fundingAgencies + urlSeparator + AdminRoutesEnum.fundingAgenciesEdit;
}
