import {DataCategoryEnum} from "@app/shared/enums/data-category.enum";
import {DataTypeEnum} from "@app/shared/enums/data-type.enum";
import {TRANSLATE} from "solidify-frontend";

export class DataCategoryHelper {
  static getDataTypeForDataCategory(dataCategory: DataCategoryEnum): DataTypeEnum[] {
    switch (dataCategory) {
      case DataCategoryEnum.Primary:
        return [
          TRANSLATE(DataTypeEnum.Observational) as DataTypeEnum,
          TRANSLATE(DataTypeEnum.Experimental) as DataTypeEnum,
          TRANSLATE(DataTypeEnum.Simulation) as DataTypeEnum,
          TRANSLATE(DataTypeEnum.Derived) as DataTypeEnum,
          TRANSLATE(DataTypeEnum.Reference) as DataTypeEnum,
          TRANSLATE(DataTypeEnum.Digitalized) as DataTypeEnum,
        ];
      case DataCategoryEnum.Secondary:
        return [
          TRANSLATE(DataTypeEnum.Publication) as DataTypeEnum,
          TRANSLATE(DataTypeEnum.DataPaper) as DataTypeEnum,
          TRANSLATE(DataTypeEnum.Documentation) as DataTypeEnum,
        ];
      case DataCategoryEnum.Package:
        return [
          TRANSLATE(DataTypeEnum.InformationPackage) as DataTypeEnum,
          TRANSLATE(DataTypeEnum.Metadata) as DataTypeEnum,
          TRANSLATE(DataTypeEnum.ExternalMetadata) as DataTypeEnum,
        ];
      case DataCategoryEnum.Software:
        return [
          TRANSLATE(DataTypeEnum.Code) as DataTypeEnum,
          TRANSLATE(DataTypeEnum.Binaries) as DataTypeEnum,
          TRANSLATE(DataTypeEnum.VirtualMachine) as DataTypeEnum,
        ];
    }
  }

  static getListDataCategory(): DataCategoryEnum[] {
    return [
      TRANSLATE(DataCategoryEnum.Primary) as DataCategoryEnum,
      TRANSLATE(DataCategoryEnum.Secondary) as DataCategoryEnum,
      TRANSLATE(DataCategoryEnum.Package) as DataCategoryEnum,
      TRANSLATE(DataCategoryEnum.Software) as DataCategoryEnum,
    ];
  }
}
