import {RoutesEnum} from "@app/shared/enums/routes.enum";
import {StringUtil} from "solidify-frontend";
import {LocalStateEnum} from "../enums/local-state.enum";

export class StoreRouteLocalUtil {
  private static readonly messageNotFound: string = "There is no route declared for '{0}' for the state '{1}'. Please add if statement into StoreRouteLocalUtil static class to manage this state.";

  static getDetailRoute(state: LocalStateEnum): RoutesEnum {
    if (state === LocalStateEnum.deposit) {
      return RoutesEnum.depositDetail;
    }
    if (state === LocalStateEnum.organizationalUnit) {
      return RoutesEnum.organizationalUnitDetail;
    }
    if (state === LocalStateEnum.admin_organizationalUnit) {
      return RoutesEnum.adminOrganizationalUnitDetail;
    }
    if (state === LocalStateEnum.admin_submissionPolicy) {
      return RoutesEnum.adminSubmissionPolicyDetail;
    }
    if (state === LocalStateEnum.admin_preservationPolicy) {
      return RoutesEnum.adminPreservationPolicyDetail;
    }
    if (state === LocalStateEnum.admin_license) {
      return RoutesEnum.adminLicenseDetail;
    }
    if (state === LocalStateEnum.admin_institution) {
      return RoutesEnum.adminInstitutionDetail;
    }
    if (state === LocalStateEnum.admin_user) {
      return RoutesEnum.adminUserDetail;
    }
    if (state === LocalStateEnum.admin_oauth2Client) {
      return RoutesEnum.adminOAuth2clientDetail;
    }
    if (state === LocalStateEnum.admin_person) {
      return RoutesEnum.adminPersonDetail;
    }
    if (state === LocalStateEnum.admin_role) {
      return RoutesEnum.adminRoleDetail;
    }
    if (state === LocalStateEnum.admin_fundingAgencies) {
      return RoutesEnum.adminFundingAgenciesDetail;
    }
    throw Error(StringUtil.format(StoreRouteLocalUtil.messageNotFound, "Detail", state));
  }

  static getCreateRoute(state: LocalStateEnum): RoutesEnum {
    if (state === LocalStateEnum.deposit) {
      return RoutesEnum.depositCreate;
    }
    if (state === LocalStateEnum.admin_organizationalUnit) {
      return RoutesEnum.adminOrganizationalUnitCreate;
    }
    if (state === LocalStateEnum.admin_submissionPolicy) {
      return RoutesEnum.adminSubmissionPolicyCreate;
    }
    if (state === LocalStateEnum.admin_preservationPolicy) {
      return RoutesEnum.adminPreservationPolicyCreate;
    }
    if (state === LocalStateEnum.admin_license) {
      return RoutesEnum.adminLicenseCreate;
    }
    if (state === LocalStateEnum.admin_institution) {
      return RoutesEnum.adminInstitutionCreate;
    }
    if (state === LocalStateEnum.admin_user) {
      return RoutesEnum.adminUserCreate;
    }
    if (state === LocalStateEnum.admin_oauth2Client) {
      return RoutesEnum.adminOAuth2clientCreate;
    }
    if (state === LocalStateEnum.admin_person) {
      return RoutesEnum.adminPersonCreate;
    }
    if (state === LocalStateEnum.admin_role) {
      return RoutesEnum.adminRoleCreate;
    }
    if (state === LocalStateEnum.admin_fundingAgencies) {
      return RoutesEnum.adminFundingAgenciesCreate;
    }
    throw Error(StringUtil.format(StoreRouteLocalUtil.messageNotFound, "Create", state));
  }

  static getRootRoute(state: LocalStateEnum): RoutesEnum {
    if (state === LocalStateEnum.deposit) {
      return RoutesEnum.deposit;
    }
    if (state === LocalStateEnum.organizationalUnit) {
      return RoutesEnum.organizationalUnit;
    }
    if (state === LocalStateEnum.admin_organizationalUnit) {
      return RoutesEnum.adminOrganizationalUnit;
    }
    if (state === LocalStateEnum.admin_submissionPolicy) {
      return RoutesEnum.adminSubmissionPolicy;
    }
    if (state === LocalStateEnum.admin_preservationPolicy) {
      return RoutesEnum.adminPreservationPolicy;
    }
    if (state === LocalStateEnum.admin_license) {
      return RoutesEnum.adminLicense;
    }
    if (state === LocalStateEnum.admin_user) {
      return RoutesEnum.adminUser;
    }
    if (state === LocalStateEnum.admin_person) {
      return RoutesEnum.adminPerson;
    }
    throw Error(StringUtil.format(StoreRouteLocalUtil.messageNotFound, "Root", state));
  }

  static getEditRoute(state: LocalStateEnum): RoutesEnum {
    if (state === LocalStateEnum.deposit) {
      return RoutesEnum.depositEdit;
    }
    if (state === LocalStateEnum.organizationalUnit) {
      return RoutesEnum.organizationalUnitEdit;
    }
    if (state === LocalStateEnum.admin_organizationalUnit) {
      return RoutesEnum.adminOrganizationalUnitEdit;
    }
    if (state === LocalStateEnum.admin_submissionPolicy) {
      return RoutesEnum.adminSubmissionPolicyEdit;
    }
    if (state === LocalStateEnum.admin_preservationPolicy) {
      return RoutesEnum.adminPreservationPolicyEdit;
    }
    if (state === LocalStateEnum.admin_license) {
      return RoutesEnum.adminLicenseEdit;
    }
    if (state === LocalStateEnum.admin_institution) {
      return RoutesEnum.adminInstitutionEdit;
    }
    if (state === LocalStateEnum.admin_user) {
      return RoutesEnum.adminUserEdit;
    }
    if (state === LocalStateEnum.admin_oauth2Client) {
      return RoutesEnum.adminOAuth2clientEdit;
    }
    if (state === LocalStateEnum.admin_person) {
      return RoutesEnum.adminPersonEdit;
    }
    if (state === LocalStateEnum.admin_role) {
      return RoutesEnum.adminRoleEdit;
    }
    if (state === LocalStateEnum.admin_fundingAgencies) {
      return RoutesEnum.adminFundingAgenciesEdit;
    }
    throw Error(StringUtil.format(StoreRouteLocalUtil.messageNotFound, "Edit", state));
  }
}
