import {LanguagesEnum} from "@app/shared/enums/languages.enum";
import {ThemeEnum} from "@app/shared/enums/theme.enum";
import {
  BaseAction,
  BaseSubAction,
} from "solidify-frontend";

export namespace AppAction {
  export class PreventExit extends BaseAction {
    static readonly type: string = "[App] Prevent Exit";

    constructor(public reasonToTranslate?: string) {
      super();
    }
  }

  export class CancelPreventExit extends BaseAction {
    static readonly type: string = "[App] Cancel Prevent Exit";
  }

  export class InitApplication extends BaseAction {
    static readonly type: string = "[App] Init Application";
  }

  export class InitApplicationSuccess extends BaseSubAction<InitApplication> {
    static readonly type: string = "[App] Init Application Success";
  }

  export class DefineFallbackLanguage extends BaseAction {
    static readonly type: string = "[App] Set Default Language";
  }

  export class SetMomentLocal extends BaseAction {
    static readonly type: string = "[App] Set Moment Local";
  }

  export class ChangeAppLanguage extends BaseAction {
    static readonly type: string = "[App] Change App Language";

    constructor(public language: LanguagesEnum) {
      super();
    }
  }

  export class ChangeAppTheme extends BaseAction {
    static readonly type: string = "[App] Change App Theme";

    constructor(public theme: ThemeEnum) {
      super();
    }
  }

  export class Login extends BaseAction {
    static readonly type: string = "[App] Login";
  }

  export class LoginSuccess extends BaseSubAction<Login> {
    static readonly type: string = "[App] Login Success";
  }

  export class LoginFail extends BaseSubAction<Login> {
    static readonly type: string = "[App] Login Fail";
  }

  export class Logout extends BaseAction {
    static readonly type: string = "[App] Logout";
  }
}
